# Node.Lua 开发指南

## 概述

Node.Lua 文档系统当前主要包含了如下内容:

- Lua 语言参考
- API 参考文档
- 实现原理
- 开发指南

## Node.lua 简介

Node.lua 是一个和 Node.js 类似的 Lua 运行环境. 

Node.lua 的目的不是为了替代 Node.js, 而是为了在嵌入式设备等性能较低的硬件上也能使用类似 Node.js 的开发和运行环境.

相比 Node.js, Node.lua 对内存等要求更低, 运行更快，和 C/C++ 混合开发更容易, 并且还能提供协程, 多线程等实用的 API.

主要问题是相对 Javascript, 使用 Lua 语言的人比较少, 但好在 Lua 和 Javascript 非常相似, 熟悉后开发起来差别不大.

### 设计目的

- 能在嵌入式环境使用脚本语言快速开发
- 能方便和 C/C++ 混合开发, Lua 主要实现胶水功能, 模块用 C/C++ 实现
- 占用 Flash 特别小 (很多嵌入式系统只有 4 到 16 MBytes)
- 启动速度快
- 跨平台, 在 Windows, Linux, macOS 上都提供一致的脚本开发环境, 这样可以在 PC 开发和调试脚本, 无需修改即可部署到开发板上.
- 提供和 Node.js 一样的 API 和模块

## Lua 语言参考

Node.Lua 选用 Lua 作为上层应用开发语言

> http://www.lua.org/

Lua 是一种轻量小巧的脚本语言，用标准 C 语言编写并以源代码形式开放， 其设计目的是为了嵌入应用程序中，从而为应用程序提供灵活的扩展和定制功能。

Lua 是巴西里约热内卢天主教大学（Pontifical Catholic University of Rio de Janeiro）里的一个研究小组于 1993 年开发的.

其设计目的是为了嵌入应用程序中，从而为应用程序提供灵活的扩展和定制功能。

### 参考手册

可以访问下面的地址查看 Lua 语言官方手册:

> [Lua 语言参考手册](lua/contents.html#index)

中文参考手册:

> [Lua 语言中文参考手册](http://www.runoob.com/manual/lua53doc/)

### 在线教程

> http://www.runoob.com/lua/lua-tutorial.html

### 主要特性

- 轻量级

它用标准 C 语言编写并以源代码形式开放，编译后仅仅一百余 KB，可以很方便的嵌入别的程序里。

- 可扩展

Lua 提供了非常易于使用的扩展接口和机制: 由宿主语言 (通常是 C 或 C++) 提供这些功能，Lua 可以使用它们，就像是本来就内置的功能一样。

### 其它特性

- 支持面向过程编程和函数式编程
- 自动内存管理
- 只提供了一种通用类型的表 (`table`)，用它可以实现数组，哈希表，集合，对象；
- 语言内置模式匹配
- 闭包 (`closure`)
- 函数也可以看做一个值
- 提供多线程 (协同进程，并非操作系统所支持的线程) 支持；
- 通过闭包和 `table` 可以很方便地支持面向对象编程所需要的一些关键机制，比如数据抽象，虚函数，继承和重载等。
